/* ***** BEGIN LICENSE BLOCK *****
 * Licensed under Version: MPL 1.1/GPL 2.0/LGPL 2.1
 * Full Terms at http://mozile.mozdev.org/license.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Playsophy code.
 *
 * The Initial Developer of the Original Code is Playsophy
 * Portions created by the Initial Developer are Copyright (C) 2002-2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  James A. Overton <james@overton.ca>
 *  Andreas Schamberger <mozile@andreass.net>
 *  Paul Everitt
 *
 * ***** END LICENSE BLOCK ***** */

var optionsPrefs="";
var mozileWindow;

function init() 
{
	netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
	optionsPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	mozileWindow = wm.getMostRecentWindow("navigator:browser");

	mozileGetAutohide();
	mozileGetCaret();
	mozileGetPrompt();
	mozileGetAccelerator();
	mozileGetOn();

	mozileGetMES();
	mozileGetExternalMES();
	mozileGetUseExternal();

	mozileGetDebugLevel();
}

function mozileGetAutohide() {
	var checkbox = document.getElementById("mozileAutohideCheckbox");
	checkbox.checked=optionsPrefs.getBoolPref("mozile.autohideBool");
}

function mozileSetAutohide(node) {
	if( optionsPrefs.getBoolPref("mozile.autohideBool") ) {
		mozileWindow.mozileTools.show();
		optionsPrefs.setBoolPref("mozile.autohideBool",false);
	}else{
		//User will have to exit, then click on something to hide toolbar...
		//because testing if toolbar should be shown is rather complicated.
		optionsPrefs.setBoolPref("mozile.autohideBool",true);
	}
}

function mozileGetCaret() {
	var checkbox = document.getElementById("mozileCaretCheckbox");
	checkbox.checked=optionsPrefs.getBoolPref("mozile.caretAlwaysOnBool");
}

function mozileSetCaret(node) {
	optionsPrefs.setBoolPref("mozile.caretAlwaysOnBool",!optionsPrefs.getBoolPref("mozile.caretAlwaysOnBool"));
}

function mozileGetPrompt() {
	var checkbox = document.getElementById("mozilePromptCheckbox");
	checkbox.checked=optionsPrefs.getBoolPref("mozile.promptOnUnloadBool");
}

function mozileSetPrompt(node) {
	optionsPrefs.setBoolPref("mozile.promptOnUnloadBool",!optionsPrefs.getBoolPref("mozile.promptOnUnloadBool"));
}

function mozileGetAccelerator() {
	var checkbox = document.getElementById("mozileAcceleratorCheckbox");
	checkbox.checked=optionsPrefs.getBoolPref("mozile.acceleratorBool");
}

function mozileSetAccelerator(node) {
	optionsPrefs.setBoolPref("mozile.acceleratorBool",!optionsPrefs.getBoolPref("mozile.acceleratorBool"));
}

function mozileGetOn() {
	var checkbox = document.getElementById("mozileOnCheckbox");
	checkbox.checked=optionsPrefs.getBoolPref("mozile.onBool");
}

function mozileSetOn(node) {
	mozileWindow.mozileToggleOnOff();
}

/* === MES Options === */

function mozileGetMES() {
	var mesName = optionsPrefs.getCharPref("mozile.MESDefaultString");
	var i = mozileWindow.mozileMES.getMESIndex(mesName);
	if ( i === null ) {
		i = 0;
	}
	var menulist = document.getElementById("mozileMESMenulist");
	menulist.selectedIndex = i;
}

function mozileSetMES(menulist) {
	var i = menulist.selectedIndex;
	var mes = mozileWindow.mozileMES.internal[i];
	optionsPrefs.setCharPref("mozile.MESDefaultString", mes);
}

function mozileGetUseExternal() {
	var checkbox = document.getElementById("mozileUseExternal");
	checkbox.checked=optionsPrefs.getBoolPref("mozile.MESUseExternalBool");
}

function mozileSetUseExternal(checkbox) {
	optionsPrefs.setBoolPref("mozile.MESUseExternalBool", checkbox.checked);
}

function mozileGetExternalMES() {
	var textbox = document.getElementById("mozileExternalMES");
	textbox.value = optionsPrefs.getCharPref("mozile.MESExternalString");
}

function mozileSetExternalMES(textbox) {
	optionsPrefs.setCharPref("mozile.MESExternalString", textbox.value);
}

function mozileClearUseExternal() {
	var checkbox = document.getElementById("mozileUseExternal");
	checkbox.checked=false;
	var textbox = document.getElementById("mozileExternalMES");
	textbox.value="";
	mozileSetExternalMES(textbox);
	mozileSetUseExternal(checkbox);
}

/* === Debug Options === */
function mozileGetDebugLevel() {
	var debugLevelMenulist = document.getElementById("mozileDebugLevelMenulist");
	debugLevelMenulist.selectedIndex=optionsPrefs.getIntPref("mozile.debugLevelInt");
}

function mozileSetDebugLevel(node) {
	switch(node.selectedIndex) {
		case 0:
			optionsPrefs.setIntPref("mozile.debugLevelInt",0);
			break;
		case 1:
			optionsPrefs.setIntPref("mozile.debugLevelInt",1);
			break;
		case 2:
			optionsPrefs.setIntPref("mozile.debugLevelInt",2);
			break;
		default:
			alert("Error: "+node.selectedIndex);
	}
}
